<?php

namespace App\Controllers\Clientes;



use App\Models\Collection;

use App\Entities\Clientes\ClienteEntity;

use App\Models\Clientes\ClienteModel;


use App\Models\Configuracion\UserModel;


class Cliente extends \App\Controllers\BaseResourceController
{

    protected $modelName = ClienteModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Cliente';
    protected static $singularObjectNameCc = 'cliente';
    protected static $pluralObjectName = 'Clientes';
    protected static $pluralObjectNameCc = 'clientes';

    protected static $controllerSlug = 'cliente';

    protected static $viewPath = 'themes/vuexy/form/clientes/cliente/';

    protected $indexRoute = 'clienteList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('Clientes.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        $this->viewData = ['usingServerSideDataTable' => true]; // JJO

        // Breadcrumbs (IMN)
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_clientes"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_cliente"), 'route' => site_url('clientes/cliente'), 'active' => true]
        ];

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('Clientes.cliente')]),
            'clienteEntity' => new ClienteEntity(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewClienteList', $viewData);
    }


    public function add()
    {

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_created_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['clienteEntity'] = isset($sanitizedData) ? new ClienteEntity($sanitizedData) : new ClienteEntity();
        $this->viewData['comunidadAutonomaList'] = $this->getComunidadAutonomaListItems($clienteEntity->comunidad_autonoma_id ?? null);
        $this->viewData['provinciaList'] = $this->getProvinciaListItems($clienteEntity->provincia_id ?? null);
        $this->viewData['paisList'] = $this->getPaisListItems($clienteEntity->pais_id ?? null);
        $this->viewData['userList'] = $this->getUserListItems($clienteEntity->comercial_id ?? null);
        $this->viewData['userList2'] = $this->getUserListItems2($clienteEntity->soporte_id ?? null);
        $this->viewData['formaDePagoList'] = $this->getFormaDePagoListItems($clienteEntity->forma_pago_id ?? null);

        $this->viewData['formAction'] = route_to('clienteAdd');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('Clientes.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {


        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $clienteEntity = $this->model->find($id);

        if ($clienteEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Clientes.cliente')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;



        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);
            if ($this->request->getPost('credito_asegurado') == null) {
                $sanitizedData['credito_asegurado'] = false;
            }
            if ($this->request->getPost('message_tracking') == null) {
                $sanitizedData['message_tracking'] = false;
            }
            if ($this->request->getPost('message_production_start') == null) {
                $sanitizedData['message_production_start'] = false;
            }
            if ($this->request->getPost('tirada_flexible') == null) {
                $sanitizedData['tirada_flexible'] = false;
            }

            // JJO
            $sanitizedData['user_updated_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Clientes.cliente'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $clienteEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult) :
                $id = $clienteEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        //var_dump($clienteEntity); dd();

        $this->viewData['clienteEntity'] = $clienteEntity;
        $this->viewData['precioTemplate'] = $this->getPrecioTemplate($id);
        $this->viewData['comunidadAutonomaList'] = $this->getComunidadAutonomaListItems($clienteEntity->comunidad_autonoma_id ?? null);
        $this->viewData['provinciaList'] = $this->getProvinciaListItems($clienteEntity->provincia_id ?? null);
        $this->viewData['paisList'] = $this->getPaisListItems($clienteEntity->pais_id ?? null);
        $this->viewData['ccaaList'] = $this->getCcaaListItems($clienteEntity->ccaa_id ?? null);
        $this->viewData['userList'] = $this->getUserListItems($clienteEntity->comercial_id ?? null);
        $this->viewData['userList2'] = $this->getUserListItems2($clienteEntity->soporte_id ?? null);
        $this->viewData['formaDePagoList'] = $this->getFormaDePagoListItems($clienteEntity->forma_pago_id ?? null);

        $this->viewData['formAction'] = route_to('clienteEdit', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('Clientes.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $searchValues = get_filter_datatables_columns($reqData);
            $requestedOrder = $reqData['order'] ?? [];

            $resourceData = $this->model->getResource($searchValues);
            foreach ($requestedOrder as $order) {
                $column = $order['column'] ?? 0;
                $dir = $order['dir'] ?? 'asc';
                $orderColumn = ClienteModel::SORTABLE[$column] ?? null;
                if ($orderColumn) {
                    $resourceData->orderBy($orderColumn, $dir);
                }
            }
            $resourceData = $resourceData->limit($length, $start)->get()->getResultObject();
            
            foreach ($resourceData as $item) :
                if (isset($item->direccion) && strlen($item->direccion) > 100) :
                    $item->direccion = character_limiter($item->direccion, 100);
                endif;
                if (isset($item->comentarios_tirada_flexible) && strlen($item->comentarios_tirada_flexible) > 100) :
                    $item->comentarios_tirada_flexible = character_limiter($item->comentarios_tirada_flexible, 100);
                endif;
                if (isset($item->comentarios_produccion) && strlen($item->comentarios_produccion) > 100) :
                    $item->comentarios_produccion = character_limiter($item->comentarios_produccion, 100);
                endif;
                if (isset($item->comentarios) && strlen($item->comentarios) > 100) :
                    $item->comentarios = character_limiter($item->comentarios, 100);
                endif;
            endforeach;

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($searchValues)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', nombre', 'nombre', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->nombre = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'nombre'];
            $onlyActiveOnes = false;
            try {
                $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            } catch (Exception $e) {
                $menu = [];
            }

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    public function getSelect2()
    {
        if ($this->request->isAJAX()) {
            $query = $this->model->builder()->select(
                [
                    "id",
                    "nombre as name"
                ]
            )->where("deleted_at", null);
            if ($this->request->getGet("q")) {
                $query->groupStart()
                    ->orLike("clientes.nombre", $this->request->getGet("q"))
                    ->groupEnd();
            }

            return $this->response->setJSON($query->get()->getResultObject());
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    protected function getPaisListItems($selId = null)
    {
        $paisModel = model('App\Models\Configuracion\PaisModel');
        $onlyActiveOnes = true;
        $data = $paisModel->getAllForMenu('id, nombre', 'nombre', $onlyActiveOnes);

        return $data;
    }

    protected function getCcaaListItems($selId = null)
    {
        $ccaaModel = model('App\Models\Configuracion\ComunidadAutonomaModel');
        $onlyActiveOnes = true;
        $data = $ccaaModel->getAllForMenu('id, nombre', 'nombre', $onlyActiveOnes);

        return $data;
    }

    protected function getUserListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('Users.user'))])];
        if (!is_null($selId)) :
            $userModel = model('App\Models\Usuarios\UserModel');

            $selOption = $userModel->where('id', $selId)->findColumn('first_name');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getComunidadAutonomaListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('ComunidadesAutonomas.comunidadAutonoma'))])];
        if (!is_null($selId)) :
            $comunidadAutonomaModel = model('App\Models\Configuracion\ComunidadAutonomaModel');

            $selOption = $comunidadAutonomaModel->where('id', $selId)->findColumn('nombre');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getUserListItems2($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('Users.user'))])];
        if (!is_null($selId)) :
            $userModel = model('App\Models\Usuarios\UserModel');

            $selOption = $userModel->where('id', $selId)->findColumn('last_name');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getFormaDePagoListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('FormasPago.formaDePago'))])];
        if (!empty($selId)) :
            $formaPagoModel = model('App\Models\Configuracion\FormaPagoModel');

            $selOption = $formaPagoModel->where('id', $selId)->findColumn('nombre');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getProvinciaListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('Provincias.provincia'))])];
        if (!empty($selId)) :
            $provinciaModel = model('App\Models\Configuracion\ProvinciaModel');

            $selOption = $provinciaModel->where('id', $selId)->findColumn('nombre');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getPrecioTemplate($cliente_id)
    {

        $modelPreciosCliente = model('App\Models\Clientes\ClientePreciosModel');
        $plantilla_id = $modelPreciosCliente->get_plantilla_precios($cliente_id);
        if (is_null($plantilla_id)) {
            return null;
        }
        $modelPlantillaPreciosCliente = model('App\Models\Clientes\ClientePlantillaPreciosModel');
        $plantilla = $modelPlantillaPreciosCliente->where("id", $plantilla_id)->where("deleted_at", null)->first();
        if ($plantilla == false) {
            return null;
        } else {
            return (object)array(
                "value" => $plantilla_id,
                "label" => $plantilla->nombre
            );
        }
    }
}
